<?php

function alphaID($in, $to_num = false, $pad_up = false, $passKey = "passedemot12eDRg5")
{
	//$index = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	$index = "abcdefghijkmnopqrstuvwxyz123456789ABCDEFGHJKLMNPQRSTUVWXYZ";
	if ($passKey !== null) {
		// Although this function's purpose is to just make the
		// ID short - and not so much secure,
		// with this patch by Simon Franz (http://blog.snaky.org/)
		// you can optionally supply a password to make it harder
		// to calculate the corresponding numeric ID

		for ($n = 0; $n<strlen($index); $n++) {
			$i[] = substr( $index,$n ,1);
		}

		$passhash = hash('sha256',$passKey);
		$passhash = (strlen($passhash) < strlen($index))
			? hash('sha512',$passKey)
			: $passhash;

		for ($n=0; $n < strlen($index); $n++) {
			$p[] =  substr($passhash, $n ,1);
		}

		array_multisort($p,  SORT_DESC, $i);
		$index = implode($i);
	}

	$base  = strlen($index);

	if ($to_num) {
		// Digital number  <<--  alphabet letter code
		$in  = strrev($in);
		$out = 0;
		$len = strlen($in) - 1;
		for ($t = 0; $t <= $len; $t++) {
			$bcpow = bcpow($base, $len - $t);
			$out   = $out + strpos($index, substr($in, $t, 1)) * $bcpow;
		}

		if (is_numeric($pad_up)) {
			$pad_up--;
			if ($pad_up > 0) {
				$out -= pow($base, $pad_up);
			}
		}
		$out = sprintf('%F', $out);
		$out = substr($out, 0, strpos($out, '.'));
	//	$out = $out / 91747464;
	} else {
		// Digital number  -->>  alphabet letter code
		//$in = $in * 91747464;
		if (is_numeric($pad_up)) {
			$pad_up--;
			if ($pad_up > 0) {
				$in += pow($base, $pad_up);
			}
		}

		$out = "";
		for ($t = floor(log($in, $base)); $t >= 0; $t--) {
			$bcp = bcpow($base, $t);
			$a   = floor($in / $bcp) % $base;
			$out = $out . substr($index, $a, 1);
			$in  = $in - ($a * $bcp);
		}
		$out = strrev($out); // reverse
	}

	return $out;
}

function dd_encode($in, $to_num = false)
{
   if (!$to_num)
   {
	   // on encode
	   $code = alphaID ($in * 91747464 , $to_num);
	   $m = crc32($code);
	   
	   $code .= "-" . alphaID ($m , $to_num);
	   
	   return $code;
   }
   else
   {
	   $crc=""; $code="";
	   list($code, $crc) = explode("-", $in);
	   
	   //echo "<br>";
	   //echo $code . "<br>" . $crc . "<br><br>";
	   
	   $crc = alphaID($crc, true);
	   //echo crc32($code) . "<br>" . $crc . "<br><br>";
	   	   
	   
	   if (crc32($code)==$crc)
	      return alphaID($code, true) /91747464 ;
	   else
	   	  return 0;
	}

}

?>
